#include "GDMO_pattern_reuse.h"

Association<Geographical_site, SLTE_agent> SLTE_agent::geographical_site = Association<Geographical_site, SLTE_agent>(1, 1, 1, 1);

Aggregation<SLTE_agent, SLTE> SLTE_agent::slte = Aggregation<SLTE_agent, SLTE>(1, 1, 1, 4);

Role<Manager> SLTE_agent::manager() const {
    Role<Geographical_site> geographical_sites = geographical_site.scan((SLTE_agent*)this);
    Role<Fault_location_manager> fault_location_managers = Geographical_site::fault_location_manager.scan(geographical_sites);
    // C++ is not Eiffel! Unfortunately, 'Role<Fault_location_manager>' does not conform to 'Role<Manager>'...
    return Role<Manager>(fault_location_managers.as_vector());
}

Composite<Network_element> SLTE_agent::managed_objects() const {
    Composite<SLTE> sltes = slte.scan((SLTE_agent*)this);
    return Composite<Network_element>(sltes.as_vector());
}

Association<Fault_location_manager, Geographical_site> Geographical_site::fault_location_manager = Association<Fault_location_manager, Geographical_site>(1, 1, 1, INT_MAX);

Association<Geographical_site, SLTE_agent> Geographical_site::slte_agent; // already initialized

Association<Fault_location_manager, Geographical_site> Fault_location_manager::geographical_site; // already initialized

Role<Agent> Fault_location_manager::agent() const {
    Role<Geographical_site> geographical_sites = geographical_site.scan((Fault_location_manager *)this);
    Role<SLTE_agent> slte_agents = Geographical_site::slte_agent.scan(geographical_sites);
    return Role<Agent>(slte_agents.as_vector());
}

Role<Network_element> Fault_location_manager::accessed_objects() const {
    Role<Geographical_site> geographical_sites = geographical_site.scan((Fault_location_manager *)this);
    Role<SLTE_agent> slte_agents_1 = Geographical_site::slte_agent.scan(geographical_sites);
    Compound<SLTE_agent> slte_agents_2(slte_agents_1.as_vector());
    Composite<SLTE> sltes = SLTE_agent::slte.scan(slte_agents_2);
    return Role<Network_element>(sltes.as_vector());
}
